"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.execShellCommand = exports.getOptions = exports.parseJsonOrDie = void 0;
const mutli_clasp_errors_1 = require("./mutli-clasp-errors");
const child_process = __importStar(require("child_process"));
/**
 * Parses input string into a valid JSON object or throws a `ClaspError` error.
 * @param value JSON string.
 */
const parseJsonOrDie = (value) => {
    try {
        return JSON.parse(value);
    }
    catch (_a) {
        throw mutli_clasp_errors_1.MultiClaspErrors.InvalidJson;
    }
};
exports.parseJsonOrDie = parseJsonOrDie;
/**
 * Get the Options for the clasp command.
 *
 * @param args array of arguments
 * @returns the string with the options, "" otherwise
 */
function getOptions(args = process.argv) {
    if (!args) {
        return "";
    }
    return args.slice(3).join(' ');
}
exports.getOptions = getOptions;
/**
 * Executes a shell command and return it as a Promise.
 * @param cmd the shell command to execute.
 * @return the promise
 */
function execShellCommand(cmd) {
    return new Promise((resolve) => {
        child_process.exec(cmd, (error, stdout, stderr) => {
            resolve({ error, stdout, stderr });
        });
    });
}
exports.execShellCommand = execShellCommand;
//# sourceMappingURL=utils.js.map